/*
   written by: p.hlstede	(peter@calvados.chemie.uni-bremen.de)

   action routines for the text widget:
   - delete line (CTRL-Y)
   - search      (CTRL-L)

							06.09.1997
 */


#include <Xm/Xm.h>
#include <Xm/Text.h>

#include "sys_consts.h"
#include "callbacks.h"
#include "globals.h"

static void NoOp(Widget w, XEvent *ev, String *params, Cardinal *num_params)
{
}

static void DeleteLine(Widget w, XEvent *ev, String *params, Cardinal *num_params)
{
   Position        x, y, h;
   XmTextPosition  pos, p_start, p_end;

   pos = XmTextGetCursorPosition(w);
   XmTextPosToXY(w, pos, &x, &y);                  /* get act. cursorpos. in pixelcoord. */

   p_start = p_end = XmTextXYToPos(w, 0, y);       /* get line start */

   for (h=1; (p_start == p_end) && (h < 100); h++) /* search for the start of the next line */
      p_end   = XmTextXYToPos(w, 0, y+h);          /* but maximal 100 pixels below */

   if (p_end != p_start)                           /* when a line is found, */
      XmTextReplace(w, p_start, p_end, "");        /* it is erased */

   XmTextSetCursorPosition(w, p_start);            /* move the cursor to the line start */
}

static void SearchAction(Widget w, XEvent *ev, String *params, Cardinal *num_params)
{
   gui_searchReplaceCB(w, (XtPointer) SEARCH, NULL);
}



static XtActionsRec actions[] =
{
   {"no-operation", NoOp},
   {"delete-line", DeleteLine},
   {"search-action", SearchAction}
};


void  InstallActions(void)
{
   XtAppAddActions(app_context, actions, XtNumber(actions));
}
